///////////////////////////////////////////////////////////////////////////////
//Standard-Map mit Möglichkeit zum zoomen und einzelne Trajektorien zu erzeugen
//Gewählte Darstellung: Zylinder  SxR
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: (Benötigt kein double, da einmalig)
float xU = -PI; float xO = PI;
float yU = -PI ; float yO = PI ;
//Grenze unveränderlich:
float xOF = PI; 

//benötigte Attribute
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double   xH, yH; 
PFont font;
float xK, yK; //Koordinaten der Punkte
float x0,y0;//Speicher für Iteration beim Fluchtdiagramm
float vergroesserung =1;;
float step;//Schrittweite bei der Abbildung eines Rechtecks
int n, i, l, L, M; //Erläuterung im setup()
int f; //für die Farbe
int iterations; //Anzahl der Iterationen für das Fluchtdiagramm
double K;// Störungsfaktor
double xFP, yFP; //Koordinaten des Fixpunktes
double xEVS, yEVS; //Eigenvektor der stabilen MF
double xEVU, yEVU; //Eigenvektor der instabilen MF
double xFPK, yFPK, xEVSK, yEVSK;//für Hufeisen (invariante MF)
double xD,yD;//Zwischenspeicer
double xA, xB, yA, yB ; //Um eine Strecke abzubilden
double  x1,y1; //Hilfsvariabel zur Streckenabbildung
float xfloatV, yfloatV, xfloatR,yfloatR;
int AnzahlHufeisenPunkte ;//Anzahl der Punkte auf dem Eigenvektor
int AnzahlIterationen ;//Anzahl der Iterationen des Eigenvektors
boolean zeichnen, trajektZeichnen, schonTransparent, achseZeichnen, fDZeichnen;
color col; //Zum einfärben des Fluchtdiagramms
PGraphics pg;
PImage bild, bildGedreht, bildZurueckGedreht;
ArrayList<PVector> punkte0 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der stabilen MF
ArrayList<PVector> punkte1 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der stabilen MF
ArrayList<PVector> punkte2 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der instabilen MF
ArrayList<PVector> punkte3 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der instabilen MF
///////////////////////////////////////////////////////////////////////////
void setup(){ 
  size(600, 600);
  background(0); 
  fill(255);
  smooth();
  textSize(16);
  pg = createGraphics(width,height);
  bild = createImage(width,height,HSB);
  bildGedreht = createImage(width,height,HSB);
  bildZurueckGedreht = createImage(width,height,HSB);
  //wichtige Parameter festlegen
  K=1.7; // K = 0.45; //K = 0.7;//K = 0.971635;//K=1;//K=1.4;//K=2.325;//K=3.5;//K=4.9976; 
  n= 10000;  //n...Anzahl der Iterationen pro Trajektorie
  L =200; //Anzahl Zufallsstartpunkte (auf 0 setzten, wenn der Hintergrund schwarz sein soll)
  l = 0; //zählt die Zufallspunkte
  M = 10000; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  xUNeu = xU; xONeu = xO;
  yUNeu = yU; yONeu = yO;
  AnzahlIterationen = 12;//Anzahl der Iterationen für das Hufeisen
  iterations = 20;//Anzahl der Iterationen für das Fluchtdiagramm
  step = 0.002;//Schrittweite bei der Abbildung eines Rechecks
  AnzahlHufeisenPunkte = 20000;//Anzahl der Punkte auf dem Eigenvektor
  println("K = "+K,"xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
  xFP = 0; //hyperbolischer Fixpunkt
  yFP = 0;
  col = color(255); 
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  achseZeichnen = true;
  fDZeichnen = false;
  strokeWeight(1);
   text("K = "+K, 20, 20);
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
     //zufällige Startpunkte aus dem angezeigten Ausschnitt  
     xH =random((float)xUNeu,(float)xONeu);    
     yH = random((float)yUNeu,(float)yONeu);
     iteriere(xH,yH,n,K); 
     if(l<L){
      l++;  
     }
       if(l>=L){
       zeichnen = false;        
       HufeisenZeichnen();
     } 
     if(l>=L && !trajektZeichnen){
         if(achseZeichnen) AchsenZeichnen(); 
         zeichnen = false;       
      // tint(255,120);//aktiviert:Bild wird teiltransparent, um die Trajektoerie besser zu sehen
     } 
   } 
   //Für Fluchtdiagramm
   if(fDZeichnen){
     background(0);
     image(pg,0,0);
    //Initialisierung der PImages
     bild = get();
     bildGedreht = get();
     bildZurueckGedreht = get();
   
     //weil negativer y-Bereich bisher oben ist: Spiegelung an x-Achse: 
     for (int i = 0; i < bild.width; i++){
        for (int j = 0; j < bild.height; j++) {
             bildGedreht.set(i,j,bild.get(i,bild.height-j-1));
            
        }
      }
    image(bildGedreht,0,0);      
    fDZeichnen = false;  
   }
 }
//Aus gegebenem Startpunkt (xH,yH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  colorMode(HSB,256,256,256); 
  i=0;
  
  xAlt = (float)xH; 
  yAlt = (float)yH;
  point(xK,yK); 
  n =   N;
  stroke(color(f%256,255,255));
    
  while(i <=n){  
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu)   % (2*Math.PI);  
       if(xNeu < -Math.PI) xNeu = 2*Math.PI+xNeu;//damit  xNeu > -PI
       if(xNeu > Math.PI) xNeu = xNeu-2*Math.PI;//damit  xNeu <  PI
       yK = map((float)yNeu,yU,yO,height,0);                 
       xK = map((float)xNeu,xU,xO,0,width);      
       point(xK,yK);   
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }
   i=0;  f++;  
}
///////////////////////////////////////////////////
void HufeisenZeichnen(){
  stabileMFZeichnen();
  instabileMFZeichnen();
  text("K = "+K, 20, 20);
}
///////////////////////////////////////////////////////
void stabileMFZeichnen(){
  punkte0.clear();  
  eigenVektorStabil();
  rueckwaertsIterieren() ;
}
//////////////////////////////////////////////////
void eigenVektorStabil(){ 
   strokeWeight(1);
   double lambda = 1+K/2-K*Math.sqrt(1/K+(float)1/4); println("Eigenwert stabile MF: "+lambda);
   xEVU = (float)1/1000; 
   yEVU = (-K/2-K*Math.sqrt(1/K+(float)1/4))/1000; println("Eigenvektor stabil: "+xEVU,yEVU);
   
  //Punkte auf Eigenvektor verteilen
  for(int i=0; i<AnzahlHufeisenPunkte;i++){
    xfloatV = (float)(xFP+i*xEVU/AnzahlHufeisenPunkte);
    yfloatV = (float)(yFP+i*yEVU/AnzahlHufeisenPunkte);
    xfloatR = (float)(xFP-i*xEVU/AnzahlHufeisenPunkte);
    yfloatR = (float)(yFP-i*yEVU/AnzahlHufeisenPunkte);
    punkte0.add(new PVector(xfloatV,yfloatV));
    punkte0.add(new PVector(xfloatR,yfloatR));
    xFPK =map(punkte0.get(i).x,xU,xO,0,width);  
    yFPK =map(punkte0.get(i).y,yU,yO,height,0);    
    if(i==0) {strokeWeight(12);stroke(color(0,255,255));}//für hyperbolischen Fixpunkt (PI,0)
    point((float)xFPK ,(float)yFPK);  
  } 
}

/////////////////////////////////////////////////////////
void rueckwaertsIterieren(){
  //Die Punkte des Eigenvektors mehrfach abbilden (stabil)
  strokeWeight(1);
   stroke(255);//weiß
   for(int j=0; j<AnzahlIterationen;j++){ 
     punkte1.clear();//Löschen noch vorhandener Punkte
     for(int i=0; i<2*AnzahlHufeisenPunkte;i++){
        xEVS = (punkte0.get(i).x - punkte0.get(i).y)%(2*Math.PI) ; 
        yEVS =  punkte0.get(i).y - K*Math.sin(xEVS); 
        
        while(xEVS <-Math.PI) xEVS = 2*Math.PI+xEVS;
        while(xEVS > Math.PI) xEVS = xEVS -2*Math.PI;
        punkte1.add(new PVector((float) xEVS , (float) yEVS ));  
      
        xEVSK =map(punkte1.get(i).x,xU,xO,0,width);  
        yEVSK =map(punkte1.get(i).y,yU,yO,height,0); 
        point((float)xEVSK ,(float)yEVSK);     
       
        punkte0.set(i,punkte1.get(i))  ;   
      }  
   }
}
/////////////////////////////////////////////////////////////
void instabileMFZeichnen(){
  
  punkte2.clear();  
  eigenVektorInstabil();
  vorwaertsIterieren();
}
//////////////////////////////////////////////////
void eigenVektorInstabil(){ 
    strokeWeight(1);
    stroke(40,255,255);
    double lambda = 1+K/2+K*Math.sqrt(1/K+(float)1/4); println("Eigenwert instabile MF: "+lambda);
    xEVU = (float)1/1000; 
    yEVU = (-K/2+K*Math.sqrt(1/K+(float)1/4))/1000; println("Eigenvektor instabil: "+xEVU,yEVU);
  
  //Punkte auf Eigenvektor verteilen
  for(int i=0; i<AnzahlHufeisenPunkte;i++){
    xfloatV = (float)(xFP+i*xEVU/AnzahlHufeisenPunkte);
    yfloatV = (float)(yFP+i*yEVU/AnzahlHufeisenPunkte);
    xfloatR = (float)(xFP-i*xEVU/AnzahlHufeisenPunkte);
    yfloatR = (float)(yFP-i*yEVU/AnzahlHufeisenPunkte);
    punkte2.add(new PVector(xfloatV,yfloatV));
    punkte2.add(new PVector(xfloatR,yfloatR));
    xFPK =map(punkte2.get(i).x,xU,xO,0,width);  
    yFPK =map(punkte2.get(i).y,yU,yO,height,0);    
    if(i==0) {strokeWeight(12);stroke(color(0,255,255));}//für hyperbolischen Fixpunkt (PI,0)
    point((float)xFPK ,(float)yFPK);  
  } 
}
////////////////////////////////////////////////////////////////
void vorwaertsIterieren(){  //Problem bei Vergrößerung
  //Die Punkte des Eigenvektors mehrfach abbilden (instabil)
  strokeWeight(1);
  stroke(40,255,255);//gelb
  for(int j=0; j<AnzahlIterationen;j++){ 
     punkte3.clear();
     for(int i=0; i<2*AnzahlHufeisenPunkte;i++){  
        yEVS =  punkte2.get(i).y + K*sin(punkte2.get(i).x); 
        xEVS = (punkte2.get(i).x + yEVS)%(2*Math.PI) ; 
        
        while(xEVS <-Math.PI) xEVS = 2*Math.PI+xEVS;
        while(xEVS > Math.PI) xEVS = xEVS -2*Math.PI;
        punkte3.add(new PVector( (float)xEVS ,  (float)yEVS ));  
      
        xEVSK =map(punkte3.get(i).x,xU,xO,0,width);  
        yEVSK =map(punkte3.get(i).y,yU,yO,height,0); 
        point((float)xEVSK ,(float)yEVSK);     
       
        punkte2.set(i,punkte3.get(i))  ;   
      }  
   }
}
/////////////////////////////////////////////////////
void zeichneFluchtdiagramm(float xmin, float ymin, float w1, float h1){
   pg.beginDraw();
      pg.loadPixels();
        float xmax = xmin + w1;       
        float ymax = ymin + h1;
      
        // die inkrimentelle Erhoehung für x und y
        float dx = (xmax - xmin) / width;
        float dy = (ymax - ymin) / height;      
        float y = ymin;
        for (int j = 0; j < height; j++) {
          float x = xmin;
          for (int i = 0; i < width; i++) {
            double D = standardMapIteration(x, y, iterations);
            pg.pixels[i+j*width] = colorize(D);               
            x += dx;
          }   
          y += dy;
        }
         pg.updatePixels();   //tint(255,220);  
    pg.endDraw(); 
    text("K = "+K, 20, 20);
}
/////////////////////////////////////////////////////////////
color colorize(double dist) {
  // jedes Pixel wird entsprechend des max Abstandes eingefärbt
      dist = dist%256;
      col = color((int)(dist),255,180); //abgedunkelt, damit man die instabile MF besser sieht
      //col = color((int)(dist+128)%255,255,(int)(6*dist)%255);   //Alternative
     return col;   
}
////////////////////////////////////////////////////////////////////
//Algorithmus zum Zeichnen des Fluchtdiagramms

double standardMapIteration(float xH, float yH, int maxN) {
  double yMin = 5;
  double yMax =-5;
  //Standardmap Algorithmus zur Berechung des Abstand des Originalpunktes zum Punkt nach maxN Iterationen
  int  maxit = maxN;
  double d = 0;
  x0 = xH; y0=yH; 
  xAlt = xH; yAlt = yH;
 
  int i = 0;
  while (i < maxit) {
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu)   % (2*Math.PI);  
      //Der Wertebereich wird hier nicht auf den Definitionsbereich eingeschränkt (modulo)
      //weil sonst die Abstandswerte d sinnlos werden können.
      //d = d +Math.sqrt((xAlt-xNeu)*(xAlt-xNeu)+(yAlt-yNeu)*(yAlt-yNeu)); 
      if(yNeu < yMin)  yMin = yNeu;
      if(yNeu > yMax)  yMax = yNeu;
      xAlt = xNeu;yAlt = yNeu;
    
    i++;
  }
   d = 200*(yMax-yMin); 
  return d; 
}
////////////////////////////////////////////////////////////////////
void rechteckAbbilden(float xLU, float yLU, int z){
   float xV = xLU;
   float yV = yLU;
   float xSchleife, ySchleife;
   float xVH, yVH;
   strokeWeight(1);
   
   while(yV < yLU-2*yLU){
     while(xV < xLU-2*yLU){
       xVH = map(xV,xU,xO,0,width);  
       yVH = map(yV,yU,yO,height,0);//println(yVH);
       while(xVH <0) xVH = width+xVH;
       while(xVH >width) xVH = xVH-width;
       stroke(255);
       point(xVH,yVH);
       xV = xV+step;
     }
     xV = xLU;
     yV = yV+step; //println(yV);
   } 
   xV = xLU;
   yV = yLU; 
   xSchleife = xV;
   ySchleife = yV;
   
   while(yV < yLU-2*yLU){    
    while(xV < xLU-2*yLU){
     xSchleife = xV;
     ySchleife = yV;
     for(int i=0; i<z;i++){
         ySchleife = ySchleife + (float)K*sin(xSchleife); 
         xSchleife = (xSchleife + ySchleife)%(2*PI) ;
         //if(xSchleife>xO)   println(i,xO,xSchleife,ySchleife);  
       
      }   
       while(xSchleife < xU) xSchleife = xSchleife + 2*xOF;
       while(xSchleife > xO) xSchleife = xSchleife - 2*xOF;
       xVH =map(xSchleife,xU,xO,0,width);  
       yVH = map(ySchleife,yU,yO,height,0);//println(yVH);
       stroke(80,255,255);
       point(xVH,yVH); //println(xVH,yVH);
       xV = xV+step; //println(xV);
     }
     xV = xLU;
     yV = yV+step; //println(yV);
   }    
   xV = xLU;
   yV = yLU; 
   xSchleife = xV;
   ySchleife = yV;
   
   
   while(yV < yLU-2*yLU){    
    while(xV < xLU-2*yLU){
     xSchleife = xV;
     ySchleife = yV;
     for(int i=0; i<z;i++){
       xSchleife = (xSchleife - ySchleife)%(2*PI) ;  
       ySchleife = ySchleife - (float)K*sin(xSchleife);       
      }   
       while(xSchleife < xU) xSchleife = xSchleife + 2*xOF;
       while(xSchleife > xO) xSchleife = xSchleife - 2*xOF;
       xVH = map(xSchleife,xU,xO,0,width);  
       yVH = map(ySchleife,yU,yO,height,0);//println(yVH);    
       stroke(0,255,255);strokeWeight(1);
       point(xVH,yVH); //println(xVH,yVH);
       xV = xV+step; //println(xV);
     }
     xV = xLU;
     yV = yV+step; //println(yV);
   } 
}
//////////////////////////////////////////////////////////////////////
void AchsenZeichnen(){
  stroke(255,200); 
  line(0,height/2,width,height/2);
  line(width/2,0,width/2,height);
}


void mousePressed() { 
  //////////////////////////////////////////////////////////
  //Trajektorie zeichnen
  //////////////////////////////////////////////////////////
   strokeWeight(1);
  if(mouseButton == LEFT){
      trajektZeichnen = true;
      if(!schonTransparent){
        //image(bild,0,0);  
        schonTransparent = true;//println("war hier");
      }   
      xH = map(mouseX,0,width,xU,xO); 
      yH = map(mouseY,0,height, yO,yU);
      println("angeklickter Punkt: "+xH,yH);
      f = f +19;     
      iteriere(xH,yH,M,K);
      M = M + 2000;
  }
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 2,5-fach vergrößert
//////////////////////////////////////////////////////
  if(mouseButton == RIGHT){
      trajektZeichnen = false;
      background(0);
      achseZeichnen = false;
      M = M +10000; //mehr Punkte auf den Trajektorien bei Vergrößerung
      xUNeu = map(mouseX,0,width,xU,xO)-(xO-xU)/5;
      xONeu = map(mouseX,0,width,xU,xO)+(xO-xU)/5;
      yUNeu = map(mouseY,0,height, yO,yU)-(yO-yU)/5;
      yONeu = map(mouseY,0,height, yO,yU)+(yO-yU)/5;
      ///////////////////////////////////////////////
      double xK = map(mouseX,0,width,xU,xO);
      double yK = map(mouseY,0,height, yO,yU);
      println("Koordinaten: "+xK, yK);
      
      /////////////////////////////////////////////
      xU =(float) xUNeu; xO =(float) xONeu; yU = (float)yUNeu; yO = (float)yONeu;
      println("xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
      l=0;
      n = 1000; //....um Hufeisen zu betonen weniger Punkte auf den Trajektorien
      zeichnen = true;  
      AnzahlHufeisenPunkte = AnzahlHufeisenPunkte*2;
      vergroesserung =vergroesserung*2.5;
      println("Vergrößerung: "+ vergroesserung);
  } 
}
////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == 'f'){
      println("Zeichne Fluchtdiagramm");
      fDZeichnen = true;
      zeichneFluchtdiagramm(xU,yU,xO-xU,yO-yU); 
  }
  
  if (key == 'h'){
      println("Zeichne Hufeisen (stabile Mannigfaltigkeit");
      stabileMFZeichnen();
  }
  
  
  if (key == 'r'){
      println("Zeichne Abbildung Rechteck");
      background(0);      
      step = step/2;//Schrittweite verkleinern
      float xRE = -0.5;
      float yRE = -0.5;//Eckpunkt des Rechtecks unten links
      int ordnung = 12; //Anzahl der Iterationen bei der Abbildung des Rechtecks
      rechteckAbbilden(xRE,yRE,ordnung);    
  }
      
  if (key == 'a'){
    AchsenZeichnen();
  }
  
  if (key == '+'){
    background(0);
    K=K+0.1;
    println("K um 0,1 erhöht. K = "+K);
    l=0;
    zeichnen = true;   
  }
  
  if (key == '-'){
    background(0);
    AnzahlIterationen = AnzahlIterationen +1;//Anpassung um genügend lange invariante Linien zu bekommen
    println("Anzahl der Iterationen für das Hufeisen: "+AnzahlIterationen);
    l=0;
    zeichnen = true;   
  }
  
  if (key == 'i'){
    background(0);
    AnzahlIterationen = AnzahlIterationen +1;//Hufeisen verlängern
    println("Anzahl der Iterationen für das Hufeisen: "+AnzahlIterationen);
    l=0;
    zeichnen = true;   
  }
  
   if (key == 'j'){
    background(0);
    AnzahlIterationen = AnzahlIterationen -1;//Hufeisen verkürzen
    println("Anzahl der Iterationen für das Hufeisen: "+AnzahlIterationen);
    l=0;
    zeichnen = true;   
  }
 
  if (key == 's'){
    save("standardMapFlucht.png");
    redraw();
  }
}
